<?php

namespace Kash;

class CacheInvalidator
{
    const CACHE_KEY_TEMPLATE = "v:%s_";

    public string $version;

    public function __construct(
        protected string $filePath,
        protected bool $updateVersion = false,
    ) {
        if ($this->updateVersion) {
            $this->version = $this->generateVersion();
            file_put_contents($this->filePath, $this->version);
        }
        else {
            $this->version = file_get_contents($this->filePath);
        }
    }

    protected function generateVersion() : string
    {
        return sprintf(static::CACHE_KEY_TEMPLATE, substr(md5(uniqid()), random_int(0, 20), random_int(6,8)));
    }

    public function __toString() : string
    {
        return $this->version;
    }
}