<?php

namespace Kash\Serialize;

class ObjectSerialize
{

    public function __construct(
        public string|null $objectType = null,
        public string|null $objectData = null,
    ) { }


    public function transform(object $object) : self
    {
        $this->objectType = $object::class;

        if ($object instanceof \Serializable) {
            $this->objectData = $object->serialize();
        }
        else {
            $this->objectData = serialize($object);
        }

        return $this;
    }

    public function restore() : object
    {
        $cls = $this->objectType;
        $obj = new $cls();

        if ($object instanceof \Serializable) {
            $obj->unserialize($this->objectData);
        }
        else {
            # unserialize()
        }

        return $obj;
    }
}